package it.cavallium.strangedb.java.objects.lists;

import it.unimi.dsi.fastutil.longs.LongArrayList;
import it.cavallium.strangedb.java.database.IDatabaseTools;
import it.cavallium.strangedb.java.annotations.DbDataType;
import it.cavallium.strangedb.java.annotations.DbField;

import java.io.IOException;

public class ObjectStrangeDbList<T> extends StrangeDbList<T> {

	@DbField(id = 0, type = DbDataType.REFERENCES_LIST)
	private LongArrayList indices;

	@Override
	protected LongArrayList getIndices() {
		return indices;
	}

	public ObjectStrangeDbList() {
		super();
	}

	public ObjectStrangeDbList(IDatabaseTools databaseTools) throws IOException {
		super(databaseTools);
		indices = new LongArrayList();
	}

	@Override
	protected T loadItem(long uid) throws IOException {
		return databaseTools.getObjectsIO().loadObject(uid);
	}

	@Override
	protected void writeItemToDisk(long uid, T item) throws IOException {
		databaseTools.getObjectsIO().setObject(uid, item);
	}
}
